/*
 *  TOPPERS/SSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 *  Copyright (C) 2011-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 * VAhCoiQB-R5F100LEpj
 */
#pragma sfr
#pragma NOP

#include <kernel.h>
#include "target_serial.h"
#include "target_syssvc.h"

/*
 * VAI/O|[gǗubNGA
 */
static SIOPCB siopcb_table[TNUM_SIOP];


/*
 * WX^ݒl
 */
#define PORT2SIOPID(x)	((x) + 1)
#define INDEX_PORT(x)	((x) - 1)
#define GET_SIOPCB(x)	(&siopcb_table[INDEX_PORT(x)])

extern void x_clear_int(INTNO intno);

/*
 * ჌xVA
 */
void target_sau_init(ID siopid)
{
	/* ς݂̏ꍇ͂Ƀ^[ */
	if(PER0 & TBIT_PER0_SAU0EN) {
		return;
	}

	/* NbN  */
	PER0 |= TBIT_PER0_SAU0EN;

	// ҂
	NOP();
	NOP();
	NOP();
	
	// CKm0 IDg fclk/8 (=2.5MHz)
	SPS0 = UINT16_C(0x0033);

	// jbg0C`l{0,1} ̓~
	ST0 |= UINT16_C(0x0003);
	
	// [hݒ
	// NbNFSPS0WX^Őݒ肵NbN̂CCK00 ̕g 
	// ]NbNFCKS00, CKS01 rbgŎw肵NbN(܂CK00)̕NbN
	// X^[ggKvFM-->\tgEFAgK̂, M-->RxD0[q
	// X^[grbgƂČo
	// UART[hC荞݂͓]
	SMR00 = UINT16_C(0x0022);
	SMR01 = UINT16_C(0x0122);
	
	// `l0: M̂݋C`l1: M̂݋
	// G[INTSREx̔֎~
	// peBȂCLSBt@[XgC1XgbvrbgC8rbgf[^
	SCR00 = UINT16_C(0x8097);
	SCR01 = UINT16_C(0x4097);

	// [rbg15:9] = 0x40 --> 64
	// VAւ̋NbN 2.5MHz(=20/8)
	//  (64+1)*2 = 130
	// 2.5[MHz]/130 = 19.23[kHz]
	SDR00 = UINT16_C(0x8000);
	SDR01 = UINT16_C(0x8000);

	// M|[g̃mCYtB^ON
	NFEN0 |= UINT8_C(0x01);

	// G[tÕNA(M̃`l1̂)
	SIR01 |= UINT16_C(0x0007);
	
	// VAf[^o͒l`l0̂1ƂD
	SO0 |= UINT16_C(0x0001);
	
	// ʐMf[^͔]̂܂܏o
	SOL0 = UINT16_C(0x0000);

	/*
	 * VA`l0Jn
	 */
	// VAo͋
	SOE0 |= UINT16_C(0x0001);

	// `l{0,1}̊Jn
	SS0 |= UINT16_C(0x0003);
}

/*
 *  SIO
 */
void sio_initialize(intptr_t exinf)
{
}

/*
 *  VAI[v
 */
SIOPCB *sio_opn_por(ID siopid, intptr_t exinf)
{
	int_t i;
	SIOPCB* p_siopcb;

	if (siopid > TNUM_PORT) {
		return NULL;
	}
	
	p_siopcb = GET_SIOPCB(siopid);
	p_siopcb->enacb &= ~TBIT_ENACB_SND;
	p_siopcb->enacb &= ~TBIT_ENACB_RCV;
	p_siopcb->exinf = exinf;
	
	// ݂̃}XN
	dis_int(INTNO_INTST0);
	dis_int(INTNO_INTSR0);
	// ݗvNA
	x_clear_int(INTNO_INTST0);
	x_clear_int(INTNO_INTSR0);

	// n[hEFȀ
	target_sau_init(siopid);	

	return p_siopcb;
}

/*
 *  VAN[Y
 */
void sio_cls_por(SIOPCB *p_siopcb)
{
	/* M֎~ */

	// `l{0,1}̒~
	ST0 |= UINT16_C(0x0003);

	/* VAW[𖳌ɂ */
	PER0 &= ~TBIT_PER0_SAU0EN;
}


/*
 *  1M
 */
bool_t
sio_snd_chr(SIOPCB *p_siopcb, char c)
{
	// Mobt@Ȃ΁C1M
	if((SSR00L & TBIT_SSRmnL_TSF) == UINT16_C(0)) {
		SDR00 = (uint16_t)c;
		
		return true;
	}

	return false;
}

/*
 *  1M
 */
int_t
sio_rcv_chr(SIOPCB *p_siopcb)
{
	int_t c = -1;

	// Mobt@Ƀf[^΁C1M
	if((SSR01L & TBIT_SSRmnL_BFF) != 0) {
		c = (int_t)SDR01;
	}

	return c;
}

/*
 *  R[obN̋
 */
void
sio_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		p_siopcb->enacb |= TBIT_ENACB_SND;
		x_clear_int(INTNO_INTST0);
		ena_int(INTNO_INTST0);
		break;
	case SIO_RDY_RCV:
		p_siopcb->enacb |= TBIT_ENACB_RCV;
		x_clear_int(INTNO_INTSR0);
		ena_int(INTNO_INTSR0);
		break;
	default:
		break;
	}
}

/* 
 *  R[obN̋֎~
 */
void
sio_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		p_siopcb->enacb &= ~TBIT_ENACB_SND;
		dis_int(INTNO_INTST0);
		x_clear_int(INTNO_INTST0);
		break;
	case SIO_RDY_RCV:
		p_siopcb->enacb &= ~TBIT_ENACB_RCV;
		dis_int(INTNO_INTSR0);
		x_clear_int(INTNO_INTSR0);
		break;
	default:
		break;
	}
}


/*
 *  ݃T[rX[`
 */

/*
 *  M
 */
void
sio_isr_rcv(intptr_t portid)
{
	SIOPCB *p_siopcb = GET_SIOPCB((ID)portid);

	if((p_siopcb->enacb & TBIT_ENACB_RCV) != 0) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sio_irdy_rcv(p_siopcb->exinf);
	}
}

/*
 *  M
 */
void
sio_isr_snd(intptr_t portid)
{
	SIOPCB *p_siopcb = GET_SIOPCB((ID)portid);

	if((p_siopcb->enacb & TBIT_ENACB_SND) != 0) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sio_irdy_snd(p_siopcb->exinf);
	}
}

/*
 *  1ói|[Oł̏ój
 */
void
sio_pol_snd_chr(char c, ID siopid)
{
	/* Mobt@ɂȂ܂ő҂(Lԓ̏) */
	while((SSR00L & TBIT_SSRmnL_TSF) != 0){}

	// 1M	
	SDR00 = (uint16_t)c;
}
